<script lang="ts">
  import { Button } from '@sveltestrap/sveltestrap';
  import { keycloak } from '../../../stores.js';
  import { updateTaskAssignee, type KanbanTask } from '../../../models/Kanban.js';

  export let task: KanbanTask;
  export let small: boolean = false;
  export let assignTask: ((task_id?: string | undefined) => void) | null = null;
  export let float: string = 'end';
  let myUserId: string | undefined;
  $: myUserId = $keycloak?.tokenParsed?.sub;
</script>

<div class={$$restProps.class || ''} on:mousedown={(event) => event.stopImmediatePropagation()}>
  {#if myUserId !== undefined && task.assignee_id !== myUserId}
    <Button
      on:click={() => updateTaskAssignee(task.id, myUserId)}
      color="secondary"
      class={`d-inline m-1 float-${float}${small ? ' btn-sm' : ''}`}
    >
      Self-Assign
    </Button>
  {/if}
  {#if task.assignee_id}
    <Button
      on:click={() => updateTaskAssignee(task.id, null)}
      color="danger"
      class={`d-inline m-1 float-${float}${small ? ' btn-sm' : ''}`}
    >
      Unassign
    </Button>
  {/if}
  {#if assignTask}
    <Button
      on:click={() => {
        if (assignTask !== null) {
          assignTask(task.id);
        }
      }}
      color="primary"
      class={`d-inline m-1 float-${float}${small ? ' btn-sm' : ''}`}
    >
      Assign To...
    </Button>
  {/if}
</div>
